(* SAUVEGARDE EN VERSION TEXTUELLE DE LA DESCRIPTION DU MONDE *)
(* SANS BSP DONNEES SORTIES DE L'EDITEUR DE NIVEAU            *)

open Sectorsbase ;;
open Linedefsbase ;;
open Vertexsbase ;;



let aDescrSaveVertexes out_channel =
 output_string out_channel "VERTEXES\n" ;
 output_string out_channel (string_of_int !nbVertexes) ;
 output_string out_channel "\n" ;
 for i=0 to !nbVertexes-1
  do
  let vert = globalvertextable.(i) in
   output_string out_channel (string_of_float vert.x) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_float vert.y) ;
   output_string out_channel "\n"
  done
;;


let aDescrSaveLinedefs out_channel =
 output_string out_channel "LINEDEFS\n" ;
 output_string out_channel (string_of_int !nbLinedefs) ;
 output_string out_channel "\n" ;
 for i=0 to !nbLinedefs-1
  do
  let line = globallinedeftable.(i) in
   output_string out_channel (string_of_int line.src) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_int line.dest) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_int line.sector) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_int line.next) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_float line.angle) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_float line.len) ;
   output_string out_channel "\n" ;
   (match (line.adjacentsector) with
      -1 -> output_string out_channel "NONE"
    | i -> output_string out_channel (string_of_int i)) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_int line.maintx) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_int line.uppertx) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_int line.lowertx) ;
   output_string out_channel "\n" ;
   output_string out_channel (string_of_bool line.passable) ;
   output_string out_channel "\n"
  done
;;


let aDescrSaveSectors out_channel =
 output_string out_channel "SECTORS\n" ;
 output_string out_channel (string_of_int !nbSectors) ;
 output_string out_channel "\n" ;
 for i=0 to !nbSectors-1
  do
  let sect = globalsectortable.(i) in
   output_string out_channel (string_of_int (List.length sect.bounds)) ;
   output_string out_channel "\n" ;
   List.iter (fun i -> output_string out_channel (string_of_int i) ;
                     output_string out_channel "\n") sect.bounds ;
  output_string out_channel (string_of_float sect.ceilingh) ;
  output_string out_channel "\n" ;
  output_string out_channel (string_of_float sect.floorh) ;
  output_string out_channel "\n"
  done
;;


let aDescrSaveDescription filename =
 let out_channel = open_out filename in
  output_string out_channel "DESCRIPTION-FILE\n" ;
  aDescrSaveVertexes out_channel ;
  aDescrSaveLinedefs out_channel ;
  aDescrSaveSectors out_channel ;
  close_out out_channel
;;

