(* SAUVEGARDE DE LA VERSION BINAIRE CAML DU MONDE COMPLET *)
(* CAD AVEC BSP. DONNEES SORTIES DU COMPILATEUR DE BSP ET *)
(* UTILISABLES DIRECTEMENT PAR LE RENDERER OCAML.         *)


open Vertexsbase ;;
open Linedefsbase ;;
open Sectorsbase ;;
open Bsptreebase ;;


let bLevelSaveVertexes out_channel =
 output_string out_channel "VERTEXES\n" ;
 output_string out_channel (string_of_int !nbVertexes) ;
 output_string out_channel "\n" ;
 for i=0 to !nbVertexes-1
  do output_value out_channel globalvertextable.(i) done
;;



let bLevelSaveLinedefs out_channel =
 output_string out_channel "LINEDEFS\n" ;
 output_string out_channel (string_of_int !nbLinedefs) ;
 output_string out_channel "\n" ;
 for i=0 to !nbLinedefs-1
  do output_value out_channel globallinedeftable.(i) done
;;



let bLevelSaveSectors out_channel =
 output_string out_channel "SECTORS\n" ;
 output_string out_channel (string_of_int !nbSectors) ;
 output_string out_channel "\n" ;
 for i=0 to !nbSectors-1
  do output_value out_channel globalsectortable.(i) done
;;


let bLevelSaveBsp out_channel tree =
 output_string out_channel "BSP-PART\n" ;
 output_value out_channel tree
;;



(* SAUVEGARDE BINAIRE DE LA BLOCKMAP *)
let bLevelSaveBlockMap out_channel nb_horiz_block nb_vert_block vert_ptr =
 output_string out_channel "BLOCKMAP\n" ;
 output_string out_channel (string_of_int nb_horiz_block) ;
 output_string out_channel "\n" ;
 output_string out_channel (string_of_int nb_vert_block) ;
 output_string out_channel "\n" ;
 output_value out_channel vert_ptr
;;



let bLevelSaveLevel filename bsptree (h, v, b) =
 let out_channel = open_out filename in
  output_string out_channel "LEVEL-FILE-BINARY\n" ;
  bLevelSaveVertexes out_channel ;
  bLevelSaveLinedefs out_channel ;
  bLevelSaveSectors out_channel ;
  bLevelSaveBsp out_channel bsptree ;
  bLevelSaveBlockMap out_channel h v b ;
  close_out out_channel
;;
