open Ascloaddescr ;;
open Bclinedefs ;;
open Bcbsptree ;;
open Ascsavelevel ;;
open Binsavelevel ;;
open Printobjects ;;
open Blockmap ;;



let outFileName = ref "" ;;

let main () =
 try
  begin
  Arg.parse [ "-version", Arg.Unit (fun () ->
                               print_string "Version 0.1\n" ;
                               print_string "Francois PESSAUX\n" ;
                               exit 0), "No doc yet..." ]
             (fun filename -> aDescrLoadDescription filename ;
                              outFileName := filename^".bsp")
             "Missing filename" ;
  let initial_line_id_list = makeListOfLinedefsVect () in
   let bsp_tree = buildTree initial_line_id_list in
    printAllData bsp_tree ;
    let (size_h, size_v, bl_map) = buildBlockMapFromBSP bsp_tree in
     printBlockMap size_h size_v bl_map ;
     if !outFileName <> "" then
      (aLevelSaveLevel !outFileName bsp_tree ;
       bLevelSaveLevel (!outFileName^".bin") bsp_tree (size_h, size_v, bl_map))
  end
 with
  exc -> Printexc.catch (fun () -> raise exc) () ;
;;

main () ;;
