open Blockmapbase ;;
open Blockmap ;;
open Linedefsbase ;;
open Vertexsbase ;;
open Floatextra ;;


(* ********************************************************************** *)
(* LES 3 FONCTIONS SUIVANTES SONT REDONDANTES AVEC CERTAINS AUTRE MODULES *)
(* MAIS CA EVITE D'INCLUDE TOUT UN TAS DE MODULE INUTILES POUR LES AVOIR. *)
(* ********************************************************************** *)

let findLinedefStart n =
 let line = globallinedeftable.(n) in
  let vertexstart = globalvertextable.(line.src) in
   (vertexstart.x, vertexstart.y)
;;


let findLinedefEnd n =
 let line = globallinedeftable.(n) in
  let vertexend = globalvertextable.(line.dest) in
   (vertexend.x, vertexend.y)
;;


(* PERMET DE SAVOIR S'IL Y A INTERSECTION ENTRE 2 SEGMENTS *)
(* L'INTERSECTION DOIT SE TROUVER <A L'INTERIEUR> DES 2 SEGMENTS *)
let existSegmentRealIntersect xa ya xb yb xc yc xd yd =
  let denom = (xb-.xa) *. (yd-.yc) -. (yb-.ya) *. (xd-.xc) in
   if float_eq denom 0.0
    then false
    else
     begin
     (* IL FAUT REGARDER SI L'INTERSECTION A BIEN LIEU *)
     (* ENTRE LES EXTREMITES DES 2 SEGMENTS. *)
     let s = ((ya-.yc) *. (xb-.xa) -. (xa-.xc) *. (yb-.ya)) /. denom in
      if (s <= 1.0 && s >= 0.0) then
       let r = ((ya-.yc) *. (xd-.xc) -. (xa-.xc) *. (yd-.yc)) /. denom in
        (r <= 1.0 && r >= 0.0)
      else false
     end
;;


let isCollision xstart ystart xend yend =
 (* START BLOCK X, ... Y *)
 let sby = (truncate ystart) / 128
 and sbx = (truncate xstart) / 128 in
  let startBlockList = (!levelBlockMap.(sby)).(sbx) in
   (* TEST DANS LE BLOC COURANT *)
   if List.exists
            (fun l_id ->
               let (x1,y1) = findLinedefStart l_id
               and (x2,y2) = findLinedefEnd l_id in
                existSegmentRealIntersect x1 y1 x2 y2 xstart ystart xend yend)
            startBlockList
    then true
    else
     begin
     (* TEST DANS LE BLOC D'ARRIVEE *)
     (* AFIN D'EVITER DES CALCULS EN TROP, IL FAUT VERIFIER *)
     (* QUE LES BLOCS DE DEPART ET D'ARRIVEE NE SONT PAS LES MEMES *)
     (* END BLOCK X, ... Y *)
     let eby = (truncate yend) / 128
     and ebx = (truncate xend) / 128 in
      let endBlockList = (!levelBlockMap.(eby)).(ebx) in
      if sby = eby && sbx = ebx then false
      else
       List.exists
             (fun l_id ->
                let (x1,y1) = findLinedefStart l_id
                and (x2,y2) = findLinedefEnd l_id in
                 existSegmentRealIntersect x1 y1 x2 y2 xstart ystart xend yend)
             endBlockList
      end
;;
