open Tk ;;
open Editorextern ;;
open Vertexsbase ;;


(* RAJOUTE LE VERTEX ET MEMORISE SON CANVAS DE REFERENCE *)
(* AU MEME INDEX DANS LA TABLE PREVUE A CET EFFET.       *)
let createNewVertex widget scale x y =
 let xstart = Pixels (x-4)
 and ystart = Pixels (y-4)
 and xend = Pixels (x+4)
 and yend = Pixels (y+4) in
  let rect_toi = Canvas.create_rectangle widget xstart ystart xend yend
                   [FillColor Blue] in
   let newvert = { x = (float x) *. scale ; y = (float y)*. scale } in
    let v_id = addVertex newvert in
     vertexWidgetTable.(v_id) <- rect_toi
;;


let computePointToVertexDist x1 y1 v_id =
 let x2 = (globalvertextable.(v_id)).x
 and y2 = (globalvertextable.(v_id)).y in
  sqrt ((x1-.x2)*.(x1-.x2)+.(y1-.y2)*.(y1-.y2))
;;

let findNearestVertex x y =
 let rec recFind index nearestdist nearestvertid =
  if (index >= !nbVertexes) then nearestvertid
  else
   let dist = computePointToVertexDist x y index in
    if dist < nearestdist then
     recFind (index+1) dist index
    else
     recFind (index+1) nearestdist nearestvertid
 in
  (* C'EST PAS GENIAL COMME INIT CAR SI ON N'A AUCUN VERTEX INFERIEUR  *)
  (* EN DISTANCE A 100000.0, CA PLANTERA. BON C'EST PEU PROBABLE, MAIS *)
  (* QUAND MEME... POUR LES PREUVES DE SURETE ON REPASSERA...          *)
  match recFind 0 100000.0 (-1) with
     -1 -> raise Not_found
   | other -> other
;;


let handleVertexSelection widget widgetinfo scale x y =
 (* SI LE VERTEX ETAIT DEJA SELECTIONNE, ALORS ON LE RETIRE DE *)
 (* LA LISTE DES VERTICES SELECTIONNES.                        *)
 (* S'IL N'Y A PAS DE shift ENFONCE, ALORS CE VERTEX RETIRE    *)
 (* TOUS LES AUTRES DE LA SELECTION ET S'Y INSTALLE TOUT SEUL. *)
 (* SINON, ON LE RAJOUTE A LA LISTE DES VERTICES SELECTIONNES. *)
 try
  let v_id = findNearestVertex (x *. scale) (y *. scale) in
  let the_vertex = globalvertextable.(v_id) in
   (* ON VIRE L'ANCIENNE INFO *)
   Text.delete widgetinfo (TextIndex ((LineChar (0,0)), []))
                                                 (TextIndex (End, [])) ;
   (* ON RAJOUTE LE NOUVELLE *)
   Text.insert widgetinfo (TextIndex (End, []))
                  ("Vertex #"^(string_of_int v_id)^"\n") [] ;
   Text.insert widgetinfo (TextIndex (End, []))
                  ("X position : "^(string_of_float the_vertex.x)^"\n") [] ;
   Text.insert widgetinfo (TextIndex (End, []))
                  ("Y position : "^(string_of_float the_vertex.y)^"\n") [] ;
   (* ON GERE LA MISE EN QUEUE MAINTENANT *)
   if List.mem v_id !selectedvertexs
    then
     begin
      selectedvertexs := Listextra.except v_id !selectedvertexs ;
      (* REINITIALISE LE COULEUR DU VERTEX *)
      Canvas.configure_rectangle widget vertexWidgetTable.(v_id)
                                                        [FillColor Blue]
     end
    else
     begin
     (match !isShiftKeyPushed with
        true -> selectedvertexs := v_id :: !selectedvertexs
      | false ->
           List.iter (fun x ->
              Canvas.configure_rectangle widget vertexWidgetTable.(x)
                                                        [FillColor Blue])
              !selectedvertexs ;
           selectedvertexs := [v_id]) ;
     (* "SURLIGNE" LE VERTEX SELECTIONE *)
     Canvas.configure_rectangle widget vertexWidgetTable.(v_id) [FillColor Red]
     end
 with Not_found -> ()
;;
