#include <mlvalues.h>
#include <alloc.h>
#include <memory.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "gif.h"

/* Exception bucket for GifError */
static value giferror_exn;

/* Initialization of TkError */
value install_giferror_exn(bucket) /* ML */
  value bucket;
{
  giferror_exn = Field(bucket, 0);
  register_global_root(&giferror_exn);
  return Val_unit;
}

value loadGifFile( path )
     value path;
{
  gdImagePtr ip;
  int i;
  FILE *fp;

  value res;
  Push_roots(r,5);

  /* no error detection */
  if( (fp = fopen( String_val( path ), "r" )) == NULL ){
    raise_with_string(giferror_exn, "File not exists"); 
  }
  if( (ip = gdImageCreateFromGif( fp  )) == NULL ){
    fclose ( fp );
    raise_with_string(giferror_exn, "GIF File read error"); 
  }
  fclose ( fp );

  r[0] = alloc_tuple( ip-> sx );
  for(i=0; i< ip-> sx; i++){
    value s;
    s = alloc_string( ip-> sy );
    bcopy(ip->pixels[i], String_val(s), ip->sy);
    Field(r[0], i) = s;
  }
  r[1] = alloc_tuple( gdMaxColors );
  r[2] = alloc_tuple( gdMaxColors );
  r[3] = alloc_tuple( gdMaxColors );
  r[4] = alloc_tuple( gdMaxColors );
  for(i=0; i< gdMaxColors; i++){
    Field(r[1], i) = Val_int( ip-> red[i] );
    Field(r[2], i) = Val_int( ip-> green[i] );
    Field(r[3], i) = Val_int( ip-> blue[i] );
    Field(r[4], i) = Val_bool( ip-> open[i] );
  }
  res = alloc_tuple(9);
  Field(res, 0) = r[0];
  Field(res, 1) = Val_int( ip-> sx );
  Field(res, 2) = Val_int( ip-> sy );
  Field(res, 3) = Val_int( ip-> colorsTotal );

  Field(res, 4) = r[1];
  Field(res, 5) = r[2];
  Field(res, 6) = r[3];

  Field(res, 7) = r[4];

  Field(res, 8) = Val_int( ip-> transparent );

  /* No use of original data. Kill it. */
  gdImageDestroy( ip );

  Pop_roots ();
  return res;
}

