open Vertexsbase ;;
open Renderextern ;;

(* ****** *)
(* LIGNES *)
(* ****** *)
type t_Linedef = {
 mutable src : int ;        (* NUMERO DE VERTEX DE DEPART DE LA LIGNE *)
 mutable dest : int ;       (* NUMERO DE VERTEX D'ARRIVEE DE LA LIGNE *)
 mutable sector : int ;     (* NUMERO DE SECTEUR AUQUEL APPARTIENT LA LIGNE *)
 mutable next : int ;       (* NUMERO DE LIGNE QUI SUIT DANS LE SECTEUR *)
 mutable angle : float ;    (* ANGLE DE LA LIGNE EN RADIANS *)
 mutable len : float ;      (* LONGUEUR DU MUR *)
 mutable adjacentsector : int ;
 (* POUR LES 3 CHAMPS CI-DESSOUS, 255 SIGNIFIE ABSENCE DE TEXTURE *)
 (* SINON CELA INDIQUE L'INDEX DE LA TEXTURE A UTILISER POUR LE   *)
 (* PAN DE MUR.                                                   *)
 mutable maintx : int ;
 mutable uppertx : int ;
 mutable lowertx : int ;
 mutable passable : bool    (* DIT SI LA LINEDEF PEUT ETRE TRAVERSEE *)
} ;;


(* ****************************************************************** *)
(* LIGNE VIDE : SERT A L'INITIALISATION DE LA TABLE GLOBALE DE LIGNES *)
(* ****************************************************************** *)
let emptyLinedef = { src = -1 ; dest = -1 ; sector = -1 ; next = -1 ;
                     angle = 0.0 ; len = 0.0 ; adjacentsector = -1 ;
                     maintx = 255 ; uppertx = 255 ;
                     lowertx = 255 ; passable = false } ;;


(* **************************************************** *)
(* TABLE GLOBALE DE LIGNES INDEXEE PAR NUMERO DE LIGNES *)
(* **************************************************** *)
let globallinedeftable = Array.create 400 emptyLinedef ;;


(* ************************************* *)
(* NOMBRE ACTUEL DE LIGNES DANS LE MONDE *)
(* ************************************* *)
let nbLinedefs = ref 0 ;;


(* ************************************************************ *)
(* AJOUTE UN VERTEX DANS LA TABLE GLOBAL ET RETOURNE SON NUMERO *)
(* ************************************************************ *)
let addLinedef l =
 let tmp = !nbLinedefs in
  globallinedeftable.(!nbLinedefs) <- l ;
  nbLinedefs := !nbLinedefs + 1 ;
  tmp
;;

