open Tk ;;
open Editorextern ;;
open Linedefsbase ;;
open Vertexsbase ;;
open Bclinedefs ;;



let redrawMap widget scale =
 (* RAFFRAICHISSEMENT DES VERTEXS *)
 for i=0 to !nbVertexes-1
  do
  let x = (globalvertextable.(i)).x
  and y = (globalvertextable.(i)).y in
   let nxstart = Pixels(truncate (x/.scale-.4.0))
   and nystart = Pixels(truncate(y/.scale-.4.0))
   and nxend = Pixels(truncate(x/.scale+.4.0))
   and nyend = Pixels(truncate(y/.scale+.4.0)) in
    Canvas.coords_set widget vertexWidgetTable.(i)
        [nxstart;nystart;nxend;nyend]
  done ;
  (* RAFFRAICHISSEMENT DES LINEDEFS *)
   for i=0 to !nbLinedefs-1
    do
     let v1_id = (globallinedeftable.(i)).src
     and v2_id = (globallinedeftable.(i)).dest in
      let v1 = globalvertextable.(v1_id)
      and v2 = globalvertextable.(v2_id) in
       let nxstart = Pixels (truncate (v1.x /. scale))
       and nystart = Pixels (truncate (v1.y /. scale))
       and nxend = Pixels (truncate (v2.x /. scale))
       and nyend = Pixels (truncate (v2.y /. scale)) in
        Canvas.coords_set widget linedefWidgetTable.(i)
            [nxstart;nystart;nxend;nyend]
    done
;;


let refreshAfterLoad widget scale =
 for i=0 to !nbVertexes-1
  do
  let x = (globalvertextable.(i)).x
  and y = (globalvertextable.(i)).y in
   let xstart = Pixels(truncate (x/.scale-.4.0))
   and ystart = Pixels(truncate(y/.scale-.4.0))
   and xend = Pixels(truncate(x/.scale+.4.0))
   and yend = Pixels(truncate(y/.scale+.4.0)) in
    let rect_toi = Canvas.create_rectangle widget xstart ystart xend yend
                   [FillColor Blue] in
     vertexWidgetTable.(i) <- rect_toi
  done ;
  for i=0 to !nbLinedefs-1
   do
    let v1_id = (globallinedeftable.(i)).src
    and v2_id = (globallinedeftable.(i)).dest in
     let v1 = globalvertextable.(v1_id)
     and v2 = globalvertextable.(v2_id) in
      let xstart = Pixels (truncate (v1.x /. scale))
      and ystart = Pixels (truncate (v1.y /. scale))
      and xend = Pixels (truncate (v2.x /. scale))
      and yend = Pixels (truncate (v2.y /. scale)) in
       let line_toi = Canvas.create_line widget [xstart;ystart;xend;yend]
                                                   [ArrowStyle Arrow_Last] in
        linedefWidgetTable.(i) <- line_toi
   done
;;

