open Renderextern ;;
open Svgalib ;;
open Gd

let initEngine () =
 for i=0 to 319
  do angleTable.(i) <- atan ((160.0 -. (float i)) /. 160.0) done ;

 for i=1 to 9999
 do invDistanceTable.(i) <- ((320.0 /. 2.0) /. (float i)) done ;

 (* load textures *)
 (* requirements:
      ./palette.dat     
         pallete data
      ./textures/config :  
         List of texture gif files (currently they must be 64x64).
	 These files must be in textures directory.
  ***)  
      
 let pal = Gd.load_palette "palette.dat" in 
 prerr_endline "palette load";

 let chconf = open_in "textures/config" in
 for i=0 to availableTextures-1 do
   let name = input_line chconf in
   prerr_endline ("loading "^name);
   let img = Gd.load_quantize pal ("textures/"^name) in
   prerr_endline ("done");
   let imgdata = Array.copy img.pixels in
    bitmaps_table.(i) <- { txData = imgdata ;
                           txWidth = img.width ;
                           txHeight = img.height }
 done ;
 close_in chconf;

 vga_lores_init () ;

 for i=0 to 255 do
   let red, green, blue = pal.(i) in
    (* ON DOIT DIVISER TOUTES LES COMPOSANTES PAR 4 POUR LA SVGALIB *)
    vga_setpalette_entry i (red/4) (green/4) (blue/4)
 done ;

  vga_keyboard_init ()
;;

