(*
#define SCANCODE_ESCAPE 1
#define SCANCODE_CURSORBLOCKUP 103
#define SCANCODE_CURSORBLOCKLEFT 105
#define SCANCODE_CURSORBLOCKRIGHT 106
#define SCANCODE_CURSORBLOCKDOWN 108
#define SCANCODE_LEFTALT 56
*)
open Binloadlevel ;;
open Renderinit ;;
open Renderview ;;
open Bsptreebase ;;
open Exitrender ;;
open Renderextern ;;
open Svgalib ;;
open Angleextra ;;
open Blockmapbase ;;
open Collision ;;


(* FRAME RATE STUFF *)
let startTime = ref 0.0 ;;
let endTime = ref 0.0 ;;
let frameCount = ref 0 ;;


let main () =
 Arg.parse [] (fun filename ->
                  let (bsp, blo) = bLevelLoadLevel filename in
                  levelBspTree := bsp ; levelBlockMap := blo)
    "Missing level filename" ;
 initEngine () ;

 startTime := Unix.gettimeofday () ;
 frameCount := 1 ;

 render_view () ;

 while true
  do
  vga_keyboard_update () ;

  if vga_keyboard_keypressed 1 then
   (begin
   endTime := Unix.gettimeofday () ;
   print_string "Frame rate : " ;
   print_float (float !frameCount /. (!endTime -. !startTime)) ;
   print_string " frames per second\n" ;
   Format.print_flush () ;
   cleanExit ()
   end) ;

   if vga_keyboard_keypressed 105 then
   (begin
   if vga_keyboard_keypressed 56 then
    (* PAS CHASSES VERS LA GAUCHE *)
    (begin
    let newx = !playerX +. (cos (toRad (!playerAngle +. 90.0)) *. 15.0)
    and newy = !playerY +. (sin (toRad (!playerAngle +. 90.0)) *. 15.0) in
     if not (isCollision !playerX !playerY newx newy) then
     (playerX := newx ;
     playerY := newy)
    end)
   else
    (* ON TOURNE A GAUCHE *)
    (begin
    playerAngle := float (((truncate !playerAngle) + 10 + 360) mod 360) ;
    playerLeftAngle := float (((truncate !playerAngle) + 45 + 360) mod 360)
    end)
   end) ;

  if vga_keyboard_keypressed 106 then
   (begin
   if vga_keyboard_keypressed 56 then
    (* PAS CHASSES VERS LA DROITE *)
    (begin
    let newx = !playerX +. (cos (toRad (!playerAngle -. 90.0)) *. 15.0)
    and newy = !playerY +. (sin (toRad (!playerAngle -. 90.0)) *. 15.0) in
     if not (isCollision !playerX !playerY newx newy) then
     (playerX := newx ;
     playerY := newy)
    end)
   else
    (* ON TOURNE A DROITE *)
    (begin
    playerAngle := float (((truncate !playerAngle) - 10 + 360) mod 360) ;
    playerLeftAngle := float (((truncate !playerAngle) + 45 + 360) mod 360)
    end)
   end) ;

  (* ON AVANCE *)
  if vga_keyboard_keypressed 103 then
   (begin
   let newx = !playerX +. (cos (toRad (!playerAngle)) *. 15.0)
   and newy = !playerY +. (sin (toRad (!playerAngle)) *. 15.0) in
    if not (isCollision !playerX !playerY newx newy) then
    (playerX := newx ;
    playerY := newy)
   end) ;

  (* ON RECULE *)
  if vga_keyboard_keypressed 108 then
   (begin
   let newx = !playerX -. (cos (toRad (!playerAngle)) *. 15.0)
   and newy = !playerY -. (sin (toRad (!playerAngle)) *. 15.0) in
    if not (isCollision !playerX !playerY newx newy) then
    (playerX := newx ;
    playerY := newy)
   end) ;

  render_view () ;
  frameCount := !frameCount + 1
  done
;;

try main ()
with
 exc ->
  print_string "It's bugged...\n"; Format.print_flush () ;
  Printexc.catch (fun () -> raise exc) () ; cleanExit ()
;;

