open Tk ;;



let singleStringRequester parentwidget message ok_action cancel_action =
  let requester_window = Toplevel.create parentwidget [] in
  Wm.title_set requester_window "Requte" ;
  Focus.set requester_window ;
  Grab.set requester_window ;
  let frame_0 = Frame.create requester_window []
  and frame_1 = Frame.create requester_window []
  and frame_2 = Frame.create requester_window [] in
   let msg_title = Label.create frame_0 [Text message]
   and logo_label = Label.create frame_0 [Bitmap (Predefined "questhead")]
   and string_entry = Entry.create frame_1 [] in
    let ok_button = Button.create frame_2 [Text "Valider";
         Width (Pixels 12);
         Command (fun () -> Grab.release requester_window;
         ok_action (Entry.get string_entry) ;
         destroy requester_window)]
    and cancel_button = Button.create frame_2 [Text "Annuler";
         Width (Pixels 12);
         Command (fun () -> Grab.release requester_window;
            cancel_action (Entry.get string_entry);
            destroy requester_window)] in
     Tk.bind string_entry [([],KeyPressDetail "Return")]
            (BindSet ([],(fun xev -> Grab.release requester_window;
            ok_action (Entry.get string_entry);
            destroy requester_window))) ;
     pack [frame_0] [] ;
     pack [frame_1] [Fill Fill_X] ;
     pack [frame_2] [Fill Fill_Both;Expand true] ;
     pack [logo_label;msg_title][Side Side_Left] ;
     pack [string_entry][Fill Fill_X] ;
     pack [ok_button;cancel_button][Side Side_Left;Fill Fill_Both;Expand true]
;;


let infoRequester parentwidget message =
  let requester_window = Toplevel.create parentwidget [] in
  Wm.title_set requester_window "Information" ;
  Focus.set requester_window ;
  Grab.set requester_window ;
  let frame_0 = Frame.create requester_window []
  and frame_1 = Frame.create requester_window [] in
   let message_title = Label.create frame_0 [Text message]
   and logo_label = Label.create frame_0 [Bitmap (Predefined "warning")]
   and ok_button = Button.create frame_1 [Text "Ok";
        Width (Pixels 12);Command (fun () -> Grab.release requester_window;
           destroy requester_window)] in
    pack [frame_0] [] ;
    pack [frame_1] [Fill Fill_Both;Expand true] ;
    pack [logo_label;message_title][Side Side_Left] ;
    pack [ok_button][Side Side_Left;Fill Fill_Both;Expand true]
;;



let yesNoRequester parentwidget message ok_action cancel_action =
  let requester_window = Toplevel.create parentwidget [] in
  Wm.title_set requester_window "Request" ;
  Focus.set requester_window ;
  Grab.set requester_window ;
  let frame_0 = Frame.create requester_window []
  and frame_1 = Frame.create requester_window [] in
   let message_title = Label.create frame_0 [Text message]
   and logo_label = Label.create frame_0 [Bitmap (Predefined "questhead")]
   and ok_button = Button.create frame_1 [Text "Yes";
        Width (Pixels 12);Command (fun () -> Grab.release requester_window;
           ok_action ();destroy requester_window)]
   and cancel_button = Button.create frame_1 [Text "No";
        Width (Pixels 12);Command (fun () -> Grab.release requester_window;
           cancel_action ();destroy requester_window)] in
    pack [frame_0] [] ;
    pack [frame_1] [Fill Fill_Both;Expand true] ;
    pack [logo_label;message_title][Side Side_Left] ;
    pack [ok_button;cancel_button][Side Side_Left;Fill Fill_Both;Expand true]
;;


let singleStringRequester parentwidget message ok_action cancel_action =
  let requester_window = Toplevel.create parentwidget [] in
  Wm.title_set requester_window "Request" ;
  Focus.set requester_window ;
  Grab.set requester_window ;
  let frame_0 = Frame.create requester_window []
  and frame_1 = Frame.create requester_window []
  and frame_2 = Frame.create requester_window [] in
   let msg_title = Label.create frame_0 [Text message]
   and logo_label = Label.create frame_0 [Bitmap (Predefined "questhead")]
   and string_entry = Entry.create frame_1 [] in
    let ok_button = Button.create frame_2 [Text "Valider";
         Width (Pixels 12);
         Command (fun () -> Grab.release requester_window;
         ok_action (Entry.get string_entry) ;
         destroy requester_window)]
    and cancel_button = Button.create frame_2 [Text "Annuler";
         Width (Pixels 12);
         Command (fun () -> Grab.release requester_window;
            cancel_action (Entry.get string_entry);
            destroy requester_window)] in
     Tk.bind string_entry [([],KeyPressDetail "Return")]
            (BindSet ([],(fun xev -> Grab.release requester_window;
            ok_action (Entry.get string_entry);
            destroy requester_window))) ;
     pack [frame_0] [] ;
     pack [frame_1] [Fill Fill_X] ;
     pack [frame_2] [Fill Fill_Both;Expand true] ;
     pack [logo_label;msg_title][Side Side_Left] ;
     pack [string_entry][Fill Fill_X] ;
     pack [ok_button;cancel_button][Side Side_Left;Fill Fill_Both;Expand true]
;;



let twoStringRequester parentwidget message1 message2 ok_action cancel_action =
  let requester_window = Toplevel.create parentwidget [] in
  Wm.title_set requester_window "Request" ;
  Focus.set requester_window ;
  let frame_0 = Frame.create requester_window []
  and frame_1 = Frame.create requester_window []
  and frame_2 = Frame.create requester_window []
  and frame_3 = Frame.create requester_window []
  and frame_6 = Frame.create requester_window [] in
   let msg_1 = Label.create frame_0 [Text message1]
   and logo_1 = Label.create frame_0 [Bitmap (Predefined "questhead")]
   and string1_entry = Entry.create frame_1 []
   and msg_2 = Label.create frame_2 [Text message2]
   and logo_2 = Label.create frame_2 [Bitmap (Predefined "questhead")]
   and string2_entry = Entry.create frame_3 [] in
    let ok_button = Button.create frame_6 [Text "Valider";
         Width (Pixels 12);
         Command (fun () -> Grab.release requester_window;
            ok_action (Entry.get string1_entry)
                   (Entry.get string2_entry) ;
            destroy requester_window)]
    and cancel_button = Button.create frame_6 [Text "Annuler";
         Width (Pixels 12);
         Command (fun () -> Grab.release requester_window;
            cancel_action (Entry.get string1_entry)
                          (Entry.get string2_entry) ;
            destroy requester_window)] in
     pack [frame_0;frame_1;frame_2;frame_3] [Fill Fill_X] ;
     pack [frame_6] [Fill Fill_Both;Expand true] ;
     pack [logo_1;msg_1][Side Side_Left] ;
     pack [string1_entry][Fill Fill_X] ;
     pack [logo_2;msg_2][Side Side_Left] ;
     pack [string2_entry][Fill Fill_X] ;
     pack [ok_button;cancel_button][Side Side_Left;Fill Fill_Both;Expand true];
     Entry.insert string1_entry End "128.0" ;
     Entry.insert string2_entry End "0.0" ;
;;
