(* ******** *)
(* SECTEURS *)
(* ******** *)
type t_Sector = {
 mutable bounds : int list ; (* LISTE DES NUMEROS DE LIGNE FORMANT *)
                             (* LE SECTEUR *)
 mutable ceilingh : float ;
 mutable floorh : float
} ;;


(* ********************************************************************** *)
(* SECTEUR VIDE : SERT A L'INITIALISATION DE LA TABLE GLOBALE DE SECTEURS *)
(* ********************************************************************** *)
let emptySector = { bounds = [] ; ceilingh = 0.0 ; floorh = 0.0 } ;;


(* ******************************************************* *)
(* TABLE GLOBALE DE SECTEURS INDEXEE PAR NUMERO DE SECTEUR *)
(* ******************************************************* *)
let globalsectortable = Array.create 400 emptySector ;;


(* *************************************** *)
(* NOMBRE ACTUEL DE SECTEURS DANS LE MONDE *)
(* *************************************** *)
let nbSectors = ref 0 ;;


(* ******************************************************************** *)
(* FONCTION QUI RAJOUTE UN SECTEUR DANS LA TABLE ET RETOURNE SON NUMERO *)
(* ******************************************************************** *)
let addSector s = 
 let tmp = !nbSectors in
  globalsectortable.(!nbSectors) <- s ;
  nbSectors := !nbSectors + 1 ;
  tmp
;;
